<?php
namespace Teknisa\OPL\Modules\Consolidacao\Services;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class OPL00800ConclusaoAutomaticaMigracaoService {
    protected $connection;
    protected $newCode;
    
    public function __construct($entityManager, $environment, $newCode) {
        $this->entityManager = $entityManager;
        $this->connection = $entityManager->getConnection();
        $this->environment = $environment;
        $this->newCode = $newCode;
    }
    
    public function realizaCommit() {
        $this->entityManager->commit();
    }
    
    public function realizaRollback() {
        $this->entityManager->rollBack();
    }
    
    public function beginTransaction() {
        $this->entityManager->beginTransaction();
    }
    
    public function getRuptura($todas) {
        $param = array();
        $param["P_RUPTURAS"]  = $todas;
        $query = "SELECT LOGRUPTURAOLAUT.NRLOGRUPTURAOLAUT, LOGRUPTURAOLAUT.DSPROCESSO, LOGRUPTURAOLAUT.DSERRO, RUPTURAOL.LISTCDOPERADOR, RUPTURAOL.LISTCDFILDEST, RUPTURAOL.CDFILIAL, RUPTURAOL.NRSEQRUPTURAOL, LOGRUPTURAOLAUT.CDFORNECED, RUPTURAOL.DATAINI, RUPTURAOL.DATAFIN, RUPTURAOL.PRODINI, RUPTURAOL.PRODFIN, TO_DATE(TO_CHAR(RUPTURAOL.DTRUPTURAOL, 'DD/MM/YYYY')) DTRUPTURAOL, FILIAL.CDFILIAL, FILIAL.NMFILIAL, LOGRUPTURAOLAUT.LISTAAF, FORNECEDOR.NRINSJURFORN, FORNECEDOR.NMFANTFORN, RUPTURAOL.LISTA_ENVIOAFFORN FROM LOGRUPTURAOLAUT, RUPTURAOL, FILIAL, FORNECEDOR WHERE LOGRUPTURAOLAUT.NRSEQRUPTURAOL = RUPTURAOL.NRSEQRUPTURAOL AND LOGRUPTURAOLAUT.CDFILIAL = RUPTURAOL.CDFILIAL AND NVL(RUPTURAOL.LISTCDOPERADOR, 'W') <> 'W' AND ( ( NVL(LOGRUPTURAOLAUT.DSPROCESSO, 'W') <> 'APURACAO' AND NVL(LOGRUPTURAOLAUT.DSERRO, 'W') <> 'NAO_HA_DADOS' AND NVL(LOGRUPTURAOLAUT.IDNOTIFICACAO, 'N') = :P_RUPTURAS ) OR ( :P_RUPTURAS = 'T' ) OR ( NVL(LOGRUPTURAOLAUT.IDNOTIFICACAO, 'W') = :P_RUPTURAS ) ) AND RUPTURAOL.CDFILIAL = FILIAL.CDFILIAL AND LOGRUPTURAOLAUT.CDFORNECED = FORNECEDOR.CDFORNECED (+) ORDER BY RUPTURAOL.LISTCDOPERADOR, RUPTURAOL.LISTCDFILDEST, RUPTURAOL.CDFILIAL, RUPTURAOL.NRSEQRUPTURAOL, LOGRUPTURAOLAUT.CDFORNECED";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            $resultado = $std->fetchAll();
            return $resultado;
        } catch(Exception $e) {
            throw $e;
        }
    }
    
    public function getParasupri($filial) {
        $param = array();
        $param["P_CDFILIPROC"]  = $filial;
        $query = "SELECT  NVL(PARASUPRI.IDUTDADOPERENVEMAIL, 'LOGIN_FILIAL_REMETENTE_FILIAL') IDUTDADOPERENVEMAIL, NVL(EF.CDSENHEMAILF, 'W') CDSENHEMAILF, EF.DSSMTPEMAILF, EF.DSLOGINSMTP, NVL(EF.DSEMAILSMTP, EF.DSLOGINSMTP) DSEMAILSMTP,  CASE WHEN NVL(EF.IDUTTLSEMAIL, 'N') = 'S' THEN 'TLS' WHEN NVL(EF.IDUTSSLEMAIL, 'N') = 'S' THEN 'SSL' END TIPOCRIPTO, FI.CDFILIAL||' - '||FI.NMFILIAL AS NMFILIAL, PARASUPRI.DSEMAILCONCLAUTRUPOL FROM FILIAL INNER JOIN FILIAL FI ON NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL)   =  FI.CDFILIAL INNER JOIN  ENDEFILI EF ON EF.CDFILIAL = FI.CDFILIAL INNER JOIN PARASUPRI ON PARASUPRI.CDFILIAL = FI.CDFILIAL WHERE FILIAL.CDFILIAL = :P_CDFILIPROC AND EF.IDTPENDEFILI = 'P'";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            $resultado = $std->fetchAll();
            return $resultado;
        } catch(Exception $e) {
            throw $e;
        }
    }
    
    public function getFornecedorRup($ruptura) {
        $param = array();
        $param["P_NRSEQENVIOAFORN"] = $ruptura["LISTA_ENVIOAFFORN"];
        $param["P_LISTCDOPERADOR"] = $ruptura["LISTCDOPERADOR"];
        $param["P_LISTCDFILDEST"]  = $ruptura["LISTCDFILDEST"];
        $param["P_DTRUPTURAOL"]    = $ruptura["DTRUPTURAOL"];
        $param["P_DATAINI"]        = $ruptura["DATAINI"];
        $param["P_DATAFIN"]        = $ruptura["DATAFIN"];
        $param["P_PRODINI"]        = $ruptura["PRODINI"];
        $param["P_PRODFIN"]        = $ruptura["PRODFIN"];
        $query = "SELECT NVL(E.IDTPENVAFNORMAL, 'E') IDTPENVAFNORMAL, E.CDFORNECED CDFORNECEDENVIO, FORNECEDOR.CDFORNECED, AUTOFORNE.NRSEQENVIOAFORN, LISTAGG(AUTOFORNE.NRAUTOFORN, ', ') WITHIN GROUP( ORDER BY AUTOFORNE.NRAUTOFORN )  NRAUTOFORN, E.NRINSJURFORN, E.NMFANTFORN FROM AUTOFORNE, FORNECEDOR, FORNECEDOR E WHERE INSTR(:P_LISTCDOPERADOR, AUTOFORNE.CDOPERADOR) > 0 AND INSTR(:P_LISTCDFILDEST, AUTOFORNE.CDFILDEST) > 0 AND AUTOFORNE.DTAUTOFORN >= :P_DTRUPTURAOL  AND AUTOFORNE.CDFORNECED = FORNECEDOR.CDFORNECED AND AUTOFORNE.IDTIPOLANCAF = 'A' AND NVL(AUTOFORNE.IDSITUATUAAF, 'N') = 'N' AND NVL(AUTOFORNE.IDAFFORALIM, 'N') = 'N' AND E.CDFORNECED = NVL(FORNECEDOR.CDFORNERELACAF, FORNECEDOR.CDFORNECED) AND INSTR(:P_NRSEQENVIOAFORN ,AUTOFORNE.NRSEQENVIOAFORN) > 0 AND EXISTS ( SELECT 1 FROM ITEMAUTF, PRODUTO WHERE ITEMAUTF.CDFILDEST = AUTOFORNE.CDFILDEST AND ITEMAUTF.CDFILLANC = AUTOFORNE.CDFILLANC AND ITEMAUTF.NRAUTOFORN = AUTOFORNE.NRAUTOFORN AND ITEMAUTF.CDPRODUTO = PRODUTO.CDPRODUTO AND NVL(ITEMAUTF.NRSEQRUPTURAOL, 'W') = 'W' AND NVL(ITEMAUTF.IDUTLITEMRUPTURA, 'N') = 'S' AND ITEMAUTF.DTPROGENTAF BETWEEN :P_DATAINI AND :P_DATAFIN AND PRODUTO.CDARVPROD BETWEEN :P_PRODINI AND :P_PRODFIN ) GROUP BY NVL(E.IDTPENVAFNORMAL, 'E'), E.CDFORNECED, FORNECEDOR.CDFORNECED, AUTOFORNE.NRSEQENVIOAFORN, E.NRINSJURFORN, E.NMFANTFORN";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            $resultado = $std->fetchAll();
            return $resultado;
        } catch(Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosForn($fornecedor) {
        $param = array();
        $param["P_CDFORNECED"] = $fornecedor;
        $query = "SELECT F.IDTPIJURFORN, F.NRINSJURFORN, F.CDFORNECED, F.NMFANTFORN, F.IDUTILZIPAF, F.IDTPENVAFNORMAL, F.IDTPENVAFFOR, F.CDFORNERELACAF AS CDFORNERELAC, NVL((SELECT LISTAGG(CASE INSTR(REPLACE(NVL(D.DSEMAILECO, D.DSLOGINECO), ';', ','), ',', -1, 1) WHEN LENGTH(REPLACE(NVL(D.DSEMAILECO, D.DSLOGINECO), ';', ',')) THEN SUBSTR(REPLACE(NVL(D.DSEMAILECO, D.DSLOGINECO), ';', ','), 1, INSTR(REPLACE(NVL(D.DSEMAILECO, D.DSLOGINECO), ';', ','), ',', -1, 1) -1) ELSE REPLACE(NVL(D.DSEMAILECO, D.DSLOGINECO), ';', ',') END, ',') WITHIN GROUP (ORDER BY NVL(D.DSEMAILECO, D.DSLOGINECO)) AS DSEMAILECO FROM DADOSFORNECOMMERCE D WHERE D.CDFORNECED  = F.CDFORNECED AND D.IDACESSOAF  = 'S'), F.DSEMAILCOT) AS DSEMAILCOT, F.DSMAILCOTCOP FROM FORNECEDOR F WHERE F.CDFORNECED = :P_CDFORNECED";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            $resultado = $std->fetchAll();
            return $resultado;
        } catch(Exception $e) {
            throw $e;
        }
    }
    
    public function atualizaLogrupturaolaut($nrLogRuptura, $processo, $erro) {
        $param = array();
        $param["P_NRLOGRUPTURAOLAUT"]  = $nrLogRuptura;
        $param["P_DSPROCESSO"]         = $processo;
        $param["P_DSERRO"]             = $erro;
        $query = "UPDATE LOGRUPTURAOLAUT SET DSPROCESSO = :P_DSPROCESSO, DSERRO = :P_DSERRO WHERE NRLOGRUPTURAOLAUT = TO_NUMBER( :P_NRLOGRUPTURAOLAUT )";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch(Exception $e) {
            throw $e;
        }
    }
    
    
    public function getConsultaFornLog($nrLogRuptura, $fornecedor) {
        $param = array();
        $param["P_NRLOGRUPTURAOLAUT"] = $nrLogRuptura;
        $param["P_CDFORNECED"]        = $fornecedor;
        $query = "SELECT NRSEQRUPTURAOL FROM LOGRUPTURAOLAUT WHERE NRLOGRUPTURAOLAUT = TO_NUMBER(:P_NRLOGRUPTURAOLAUT) AND NVL(CDFORNECED, NVL(:P_CDFORNECED, 'W')) = NVL(:P_CDFORNECED, 'W')";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            $resultado = $std->fetchAll();
            return $resultado;
        } catch(Exception $e) {
            throw $e;
        }
    }
    
    public function insLogrupturaolautforn($ruptura, $filial, $processo, $erro, $fornecedor) {
        $param = array();
        $param["P_NRSEQRUPTURAOL"]   = $ruptura;
        $param["P_CDFILIAL"]         = $filial;
        $param["P_DSPROCESSO"]       = $processo;
        $param["P_DSERRO"]           = $erro;
        $param["P_CDFORNECED"]       = $fornecedor;
        $query = "INSERT INTO LOGRUPTURAOLAUT(NRLOGRUPTURAOLAUT, NRSEQRUPTURAOL, CDFILIAL, DTOPERACAO, DSPROCESSO, DSERRO, CDFORNECED) VALUES (SEQ_NRLOGRUPTURAOLAUT.NEXTVAL, :P_NRSEQRUPTURAOL, :P_CDFILIAL, SYSDATE, :P_DSPROCESSO, SUBSTR( :P_DSERRO , 1, 2000), :P_CDFORNECED)";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch(Exception $e) {
            throw $e;
        }
    }
    
    public function atualizaLogrupturaolautForn($nrLogRuptura, $processo, $erro, $fornecedor) {
        $param = array();
        $param["P_NRLOGRUPTURAOLAUT"]  = $nrLogRuptura;
        $param["P_DSPROCESSO"]         = $processo;
        $param["P_DSERRO"]             = $erro;
        $param["P_CDFORNECED"]         = $fornecedor;
        $query = "UPDATE LOGRUPTURAOLAUT SET DSPROCESSO = :P_DSPROCESSO, DSERRO = :P_DSERRO, CDFORNECED = :P_CDFORNECED WHERE NRLOGRUPTURAOLAUT = TO_NUMBER(:P_NRLOGRUPTURAOLAUT) AND NVL(CDFORNECED, NVL(:P_CDFORNECED, 'W')) = NVL(:P_CDFORNECED, 'W')";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch(Exception $e) {
            throw $e;
        }
    }
    
    public function atualizaLogrupturaolautFinal($nrLogRuptura) {
        $param = array();
        $param["P_NRLOGRUPTURAOLAUT"]  = $nrLogRuptura;
        $query = "UPDATE LOGRUPTURAOLAUT SET IDNOTIFICACAO = 'S', DTOPERACAO = SYSDATE WHERE NRLOGRUPTURAOLAUT = TO_NUMBER( :P_NRLOGRUPTURAOLAUT )";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch(Exception $e) {
            throw $e;
        }
    }
    
    public function atualizaAFGeral($ruptura, $dserro, $af, $fornecedorAF) {
        $param = array();
        $param["P_DSMOTIVOENVAFOR"] = $dserro;
        $param["P_NRAUTOFORN"]      = $af;
        $param["P_CDFORNECED"]      = $fornecedorAF;
        $param["P_LISTCDOPERADOR"]  = $ruptura["LISTCDOPERADOR"];
        $param["P_LISTCDFILDEST"]   = $ruptura["LISTCDFILDEST"];
        $param["P_DTRUPTURAOL"]     = $ruptura["DTRUPTURAOL"];
        $param["P_DATAINI"]         = $ruptura["DATAINI"];
        $param["P_DATAFIN"]         = $ruptura["DATAFIN"];
        $param["P_PRODINI"]         = $ruptura["PRODINI"];
        $param["P_PRODFIN"]         = $ruptura["PRODFIN"];
        $query = "UPDATE AUTOFORNE SET DSMOTIVOENVAFOR = :P_DSMOTIVOENVAFOR WHERE INSTR(:P_LISTCDOPERADOR, AUTOFORNE.CDOPERADOR) > 0 AND INSTR(:P_LISTCDFILDEST, AUTOFORNE.CDFILDEST) > 0 AND ( ( INSTR(:P_NRAUTOFORN, AUTOFORNE.NRAUTOFORN) > 0 ) OR ( :P_NRAUTOFORN = 'T' ) ) AND AUTOFORNE.DTAUTOFORN >= :P_DTRUPTURAOL AND NVL(AUTOFORNE.CDFORNECED, 'N') = NVL(:P_CDFORNECED, AUTOFORNE.CDFORNECED) AND AUTOFORNE.IDTIPOLANCAF = 'A' AND NVL(AUTOFORNE.IDSITUATUAAF, 'N') = 'N' AND NVL(AUTOFORNE.IDAFFORALIM, 'N') = 'N' AND EXISTS ( SELECT 1 FROM ITEMAUTF, PRODUTO WHERE ITEMAUTF.CDFILDEST = AUTOFORNE.CDFILDEST AND ITEMAUTF.CDFILLANC = AUTOFORNE.CDFILLANC AND ITEMAUTF.NRAUTOFORN = AUTOFORNE.NRAUTOFORN AND ITEMAUTF.CDPRODUTO = PRODUTO.CDPRODUTO AND NVL(ITEMAUTF.NRSEQRUPTURAOL, 'W') = 'W' AND NVL(ITEMAUTF.IDUTLITEMRUPTURA, 'N') = 'S' AND ITEMAUTF.DTPROGENTAF BETWEEN :P_DATAINI AND :P_DATAFIN AND PRODUTO.CDARVPROD BETWEEN :P_PRODINI AND :P_PRODFIN )";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch(Exception $e) {
            throw $e;
        }
    }
}