<?php
namespace Teknisa\OPL\Modules\Relatorios\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;

class RelatorioInconsistenciaController extends \Zeedhi\Framework\Controller\Report {
    
    protected $entityManager;
    protected $qr2Strategy;
    protected $birtStrategy;
    protected $newCode;
    protected $environment;
    protected $connection;
    protected $stNomeRel;
    protected $globalReports = [];
    
    public function __construct($reportService, $entityManager,  $birtStrategy, $qr2Strategy, $newCode, $environment, $connection) {
        $this->reportService = $reportService;
        $this->entityManager = $entityManager;
        $this->birtStrategy  = $birtStrategy;
        $this->qr2Strategy   = $qr2Strategy;
        $this->newCode       = $newCode;
        $this->environment   = $environment;
        $this->connection    = $connection;
    }
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        ini_set('default_socket_timeout', 10000);
        $row = $request->getRow();
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
        $this->stNomeRel = $this->getReportName($row);
        $this->reportMapping[$this->stNomeRel] = array (
            'strategy' => isset($row["STRATEGY"]) ? $row["STRATEGY"] : "QR2",
            'parameterMapping' => array (
                'P_CDFILIALOL'      => 'P_CDFILIALOL',
                'P_CDOPERADOR'      => 'P_CDOPERADOR',
                'P_DTINICIAL'       => 'P_DTINICIAL',
                'P_DTFINAL'         => 'P_DTFINAL',
                'P_NRLOGCORTEOL'    => 'P_NRLOGCORTEOL',
                'P_CDFILCENTCMP'    => 'P_CDFILCENTCMP',
                'P_NRAPURPREC'      => 'P_NRAPURPREC',
                'NRORG'             => 'NRORG'
            )
        );
    }
    
    public function afterProcessReport(DTO\Request\Row $request, DTO\Response $response, $report) {
        $row = $request->getRow();
        print_r($this->globalReports[$row["reportLabel"]] = $report);die;
        $this->globalReports[$row["reportLabel"]] = $report;
    }
}